package me.Demon.BlockWars.Game;

import me.Demon.BlockWars.Main;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.configuration.ConfigurationSection;

public class Region {

    private World world;
    private Point min;
    private Point max;

    public Region(World world, Point min, Point max) {
        this.world = world;
        this.min = min;
        this.max = max;
    }

    public Location getHub(){
        double z = (min.getZ() + max.getZ()) / 2;
        double y = min.getY();
        if(max.getY() > y){
            y = max.getY();
        }
        int backhub = Main.configYml.getGameSettings("backhub");
        if(backhub == 1){
            double x = (max.getX() - 1);
            return new Location(world,x,(y+5),z,90,90);
        }else if(backhub == 2){
            double x = (min.getX() + 1);
            return new Location(world,x,(y+5),z,-90,90);
        }
        double x = (min.getX() + max.getX()) / 2;
        return new Location(world,x,(y+5),z,-90,90);
    }
    /*public Location getHub(){
        double x = (min.getX() + max.getX()) / 2;
        double z = (min.getZ() + max.getZ()) / 2;
        double y = min.getY();
        if(max.getY() > y){
            y = max.getY();
        }
        return new Location(world,x,(y+10 ),z,90,0);
    }*/

    public World getWorld() {
        return world;
    }

    public Point getMin() {
        return min;
    }

    public Point getMax() {
        return max;
    }

    public void setMax(Point max) {
        this.max = max;
    }

    public void setMin(Point min) {
        this.min = min;
    }

    public static Region deserialize(ConfigurationSection section) {
        World world1 = Bukkit.getWorld(section.getString("world"));
        Point point1 = Point.deserialize(section.getConfigurationSection("min"));
        Point point2 = Point.deserialize(section.getConfigurationSection("max"));
        return new Region(world1, point1, point2);
    }
    public static Region deserialize(String worldName,Point point_min,Point point_max) {
        World world1 = Bukkit.getWorld(worldName);
        return new Region(world1,point_min,point_max);
    }

    public boolean isInRegion(Location location) {
        if (!location.getWorld().getName().equalsIgnoreCase(world.getName())) {
            return false;
        }
        return (location.getBlockX() >= this.min.getX()
                && location.getBlockX() <= this.max.getX()
                && location.getBlockY() >= this.min.getY()
                && location.getBlockY() <= this.max.getY()
                && location.getBlockZ() >= this.min.getZ()
                && location.getBlockZ() <= this.max.getZ());
    }
    public boolean isInBreakRegion(Location location) {
        if (!location.getWorld().getName().equalsIgnoreCase(world.getName())) {
            return false;
        }
        return (location.getBlockX() >= (this.min.getX()-5)
                && location.getBlockX() <= (this.max.getX()+5)
                && location.getBlockZ() >= (this.min.getZ()-5)
                && location.getBlockZ() <= (this.max.getZ()+5));
    }
    public boolean isInRegionPlayer(Location location) {
        if (!location.getWorld().getName().equalsIgnoreCase(world.getName())) {
            return false;
        }
        return (location.getBlockX() >= this.min.getX()
                && location.getBlockX() <= this.max.getX()
                && location.getBlockY() >= this.min.getY()
                && location.getBlockZ() >= this.min.getZ()
                && location.getBlockZ() <= this.max.getZ());
    }

}
