package me.Demon.BlockWars.Listener;

import cn.hamster3.cdapi.CDTimeAPI;
import me.Demon.BlockWars.Game.Region;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.GameUtil;
import me.Demon.BlockWars.api.BlockWarsAPI;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockExplodeEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerPickupItemEvent;
import org.bukkit.event.player.PlayerSwapHandItemsEvent;
import org.bukkit.event.server.ServerListPingEvent;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.Iterator;

/*
* GameListener
* 用途: 游戏中搭方块、禁止破坏、tnt保护
*
* */
public class GameListener implements Listener {

    @EventHandler
    public void onPing(ServerListPingEvent e){
        if (Main.gameData.isStarted()) {
            e.setMotd("§a整蛊模式: §6TNT填充  §a当前版本: §6常规版 §b运行中");
        }else{
            e.setMotd("§a整蛊模式: §6TNT填充  §a当前版本: §6常规版 §c未运行");
        }
    }

    @EventHandler
    public void onSwap(PlayerSwapHandItemsEvent e) {
        Player p = e.getPlayer();
        e.setCancelled(true);
        if (!p.isSneaking()) {
            p.addPotionEffect(new PotionEffect(PotionEffectType.FAST_DIGGING, 20 * 60, 0,false,false));
            p.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 20 * 60, 2,false,false));
            long anti_spawn = CDTimeAPI.getCD(p.getUniqueId(),"anti_spawn");
            if(anti_spawn < 1) {
                p.teleport(Main.gameData.getRegion().getHub());
            }else{
                double time = (double) (anti_spawn / 1000);
                p.sendMessage("§c[系统]§a整蛊效果生效中...§e"+String.format("%.1f",time)+"秒§a才能传送.");
                p.teleport(p.getLocation().add(0,100,0));
            }
        }
    }

    /*
    * 若玩家是创造模式没有SHIFT蹲下的情况下会切换成观察者模式
    * */
    @EventHandler
    public void onPick(PlayerDropItemEvent e){
        Player p = e.getPlayer();
        if (Main.gameData.isStarted()) {
            if(p.isSneaking()){
                // RepairGiftGui.OpenGui(p);
            } else {
                if (p.getGameMode() == GameMode.CREATIVE) {
                    p.setGameMode(GameMode.SPECTATOR);
                }
            }
            e.setCancelled(true);
        }
    }

    /*
    * 若玩家是观察者模式 任意交互均可切换回创造模式
    * */
    @EventHandler
    public void onUse(PlayerInteractEvent e){
        Player p = e.getPlayer();
        if (Main.gameData.isStarted()) {
            if (p.getGameMode() == GameMode.SPECTATOR) {
                p.setGameMode(GameMode.CREATIVE);
            }
        }
    }

    /*
    * 禁止破坏游戏区域外的方块
    * */
    @EventHandler
    public void onBlockBreak(BlockBreakEvent event) {
        Block block = event.getBlock();
        if (Main.gameData.isStarted()) {
            Region region = Main.gameData.getRegion();
            if (region.isInRegionPlayer(block.getLocation())) {
                event.setCancelled(false);
            }else if(region.isInBreakRegion(block.getLocation())){
                event.setCancelled(true);
            }
        }
    }

    @EventHandler  //*禁止在游戏区外放置方块*//
    public void onUsePlace(PlayerInteractEvent e) {
        Player p = e.getPlayer();
        Block block = e.getClickedBlock();
        if(e.getAction() == Action.RIGHT_CLICK_BLOCK) {
            if (Main.gameData.isStarted()) {
                if(Main.configYml.isGameSettings("speedplace")) {
                    Region region = Main.gameData.getRegion();
                    // 检测方块是否在游戏场地
                    if (region.isInRegion(block.getLocation())) {
                        // 检测方块下方是否存在空缺
                        Location location = block.getLocation();
                        int indexY = location.getBlockY();
                        for (int y = (int) region.getMin().getY(); y < indexY; y++) {
                            Block block1 = location.getWorld().getBlockAt(location.getBlockX(), y, location.getBlockZ());
                            if (block1.getType().equals(Material.AIR)) {
                                indexY = y;
                                break;
                            }
                        }
                        if(location.getY() == indexY){
                            return;
                        }
                        e.setCancelled(true);
                        Block block1 = location.getWorld().getBlockAt(location.getBlockX(), indexY, location.getBlockZ());
                        Main.gameData.updateBlockType(block1);
                        GameUtil.refreshPlayerHandStack(p);
                        boolean sounds_butt = Main.configYml.isGameSettings("placesounds");
                        if(sounds_butt) {
                            p.playSound(p.getLocation(), Sound.BLOCK_AMETHYST_BLOCK_PLACE, 1, 1);
                        }
                    }
                }
            }
        }
    }

    /*
    * 启动快速搭建方块
    * */
    @EventHandler
    public void onBlockPlace(BlockPlaceEvent event) {
        Player p = event.getPlayer();
        World world = p.getWorld();
        Block block = event.getBlockPlaced();
        if (Main.gameData.isStarted()) {
            Region region = Main.gameData.getRegion();
            if (region.isInRegion(block.getLocation())) {
                boolean sounds_butt = Main.configYml.isGameSettings("placesounds");
                if(Main.configYml.isGameSettings("speedplace")) {
                    if (!isPlaceNextBlock(block)) {
                        GameUtil.refreshPlayerHandStack(p);
                        Main.gameData.updateBlockType(block);
                        if(sounds_butt) {
                            p.playSound(p.getLocation(), Sound.BLOCK_AMETHYST_BLOCK_PLACE, 1.0F, 1.0F);
                        }
                        return;
                    }
                    long startTime = System.currentTimeMillis(); // 记录开始时间
                    Location location = block.getLocation();
                    int indexY = location.getBlockY();
                    for (int y = (int) region.getMin().getY(); y < indexY; y++) {
                        Block block2 = location.getWorld().getBlockAt(location.getBlockX(), y, location.getBlockZ());
                        if (block2.getType().equals(Material.AIR)) {
                            indexY = y;
                            break;
                        }
                    }
                    event.setCancelled(true);
                    int a = 1;
                    for (int place_y = indexY; place_y <= (indexY+3); place_y++) {
                        int finalPlace_y = place_y;
                        new BukkitRunnable() {
                            @Override
                            public void run() {
                                Block block1 = world.getBlockAt(location.getBlockX(), finalPlace_y, location.getBlockZ());
                                if (block1.getType().equals(Material.AIR)) {
                                    Main.gameData.updateBlockType(block1);
                                    if (sounds_butt) {
                                        p.playSound(p.getLocation(), Sound.BLOCK_METAL_PLACE, 1.0F, 1.0F);
                                        p.playSound(p.getLocation(), Sound.BLOCK_AMETHYST_BLOCK_PLACE, 1.0F, 1.0F);
                                    }
                                    cancel();
                                }
                            }
                        }.runTaskLater(Main.plugin, a);
                        a++;
                    }
                    GameUtil.refreshPlayerHandStack(p);
                    long endTime = System.currentTimeMillis(); // 记录结束时间
                    long duration = endTime - startTime; // 计算耗时
                    System.out.println("[调试 - 快速] 本次搭建总计耗时 " + duration + " ms");
                }else{
                    if(sounds_butt) {
                        p.playSound(p.getLocation(), Sound.BLOCK_AMETHYST_BLOCK_PLACE, 1.0F, 1.0F);
                    }
                }
            } else if(Main.gameData.getRegion().isInBreakRegion(block.getLocation())){
                event.setCancelled(true);
            }
        }
    }
    /*
    * 检测方块下方是否是空气
    * */
    public boolean isPlaceNextBlock(Block block){
        Location location = block.getLocation();
        int indexY = location.getBlockY();
        Block block_next = location.getWorld().getBlockAt(location.getBlockX(), indexY-1, location.getBlockZ());
        if (block_next.getType().equals(Material.AIR)) {
            return true;
        }
        return false;
    }

    /*
     * 当发生爆炸时检测被炸方块是否有保护
     * */
    @EventHandler
    public void onBlockExplode(BlockExplodeEvent event) {
        if (Main.gameData.isStarted()) {
            Iterator<Block> iterator = event.blockList().iterator();
            while (iterator.hasNext()) {
                Block block = iterator.next();
                if (Main.gameData.getRegion().isInRegion(block.getLocation())) {
                    block.breakNaturally();
                }else if(!Main.gameData.getRegion().isInBreakRegion(block.getLocation())){
                    block.breakNaturally();
                }
                iterator.remove();
            }
        }
    }
    /*
    * 当发生爆炸时检测被炸方块是否有保护
    * */
    @EventHandler
    public void onEntityExplode(EntityExplodeEvent event) {
        if (Main.gameData.isStarted()) {
            Iterator<Block> iterator = event.blockList().iterator();
            while (iterator.hasNext()) {
                Block block = iterator.next();
                if (Main.gameData.getRegion().isInRegion(block.getLocation())) {
                    block.breakNaturally();
                }else if(!Main.gameData.getRegion().isInBreakRegion(block.getLocation())){
                    block.breakNaturally();
                }
                iterator.remove();
            }
        }
    }

    /*
    * 拾取任何物品不进入背包直接清理
    * */
    @EventHandler
    public void onPick(PlayerPickupItemEvent e){
        Player p = e.getPlayer();
        p.playSound(p.getLocation(), Sound.ENTITY_ITEM_PICKUP,1,1);
        e.setCancelled(true);
        e.getItem().remove();
    }
}
