package me.Demon.BlockWars.Listener;

import me.Demon.BlockWars.Main;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBurnEvent;
import org.bukkit.event.block.BlockIgniteEvent;
import org.bukkit.event.entity.*;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.weather.WeatherChangeEvent;

/*
* GamePotect
* 用途: 保护游戏世界
* */
public class GamePotect implements Listener {

    @EventHandler/*禁止史莱姆分裂*/
    public void onSlimeSplit(SlimeSplitEvent event) {
        event.setCancelled(true);
    }

    @EventHandler /*保护农作物免踩踏*/
    public void onJumpFarm(PlayerInteractEvent e){
        if (e.isCancelled()) {return;}
        if(e.getAction() == Action.PHYSICAL){
            Block block = e.getClickedBlock();
            if(block.getType() == Material.FARMLAND){
                e.setCancelled(true);
            }
        }
    }

    @EventHandler /*保护农作物免踩踏*/
    public void onMobsFarm(EntityInteractEvent e){
        if (e.isCancelled()) {return;}
        if(e.getEntityType() != EntityType.PLAYER){
            Block block = e.getBlock();
            if(block.getType() == Material.FARMLAND){
                e.setCancelled(true);
            }
        }
    }

    @EventHandler /*生物免摔落伤害*/
    public void onAntiFall(EntityDamageEvent event) {
        if(event.getEntity() instanceof Player){
            event.setDamage(0);
        }
        if (event.getCause().equals(EntityDamageEvent.DamageCause.FALL)) {
            event.setCancelled(true);
        }
        if(event.getEntityType() == EntityType.PIG) {
            if(Main.configYml.isGameSettings("pigkills")) {
                if (event.getCause() != EntityDamageEvent.DamageCause.ENTITY_ATTACK) {
                    event.setDamage(0);
                }
            }
        }
    }
    @EventHandler
    public void onEntityCombust(EntityCombustEvent event) {
        if (event.getEntity() instanceof LivingEntity) {
            event.setCancelled(true); // 取消生物燃烧

        }
    }

    @EventHandler
    public void onEntityDamageByBlock(EntityDamageByBlockEvent event) {
        if (event.getEntity() instanceof LivingEntity) {
            if(event.getDamager() != null) {
                if (event.getDamager().getType().name().contains("MAGMA")) {
                    event.setCancelled(true);
                }
            }
        }
    }

    @EventHandler(priority= EventPriority.HIGH)
    public void onWeatherChange(WeatherChangeEvent e) {
        e.setCancelled(true);
    }
    @EventHandler/*禁止火焰传播*/
    public void onBlockFire(BlockBurnEvent e) {
        e.setCancelled(true);
    }
    @EventHandler/*禁止火焰点燃物品*/
    public void onBlockIgnite(BlockIgniteEvent e) {
        e.setCancelled(true);
    }
}
