package me.Demon.BlockWars.Manager;

import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.regions.CuboidRegion;
import me.Demon.BlockWars.Game.BlockRegion;
import me.Demon.BlockWars.Game.GameData;
import me.Demon.BlockWars.Game.Point;
import me.Demon.BlockWars.Game.Region;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.ComputeBlock;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.World;

import java.util.List;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.atomic.AtomicInteger;

public abstract class MinerOperate {

    /*
    * 初始化矿区大小
    * */
    public static void initializeMinerSize() {
        int min_minerY = 10;
        int max_minerY = 18;
        GameData gameData = Main.gameData;
        Region region = new Region(Bukkit.getWorld("world"),new Point(103,min_minerY,-6),new Point(113, max_minerY, 4));
        gameData.setRegion(region);
        gameData.setCompleteBlockGoal(ComputeBlock.getCompleteBlockGoal(region));
    }
    public static void clearMinerAll(List<BlockRegion> blockRegionList){
        World world = Main.gameData.getWorld();
        Material material = Material.AIR;
        for (BlockRegion blockRegion : blockRegionList) {
            CompletableFuture.runAsync(() -> {
                long startTime = System.currentTimeMillis(); // 记录开始时间
                int minX = blockRegion.getMinX();
                int maxX = blockRegion.getMaxX();
                CuboidRegion cuboidRegion = ComputeBlock.getCuboidRegion(minX,maxX);
                try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(world))) {
                    // 在编辑会话中设置长方体区域内的所有方块为指定的材质
                    editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(material));
                } catch (Exception e) {
                    // 捕获并打印任何可能发生的异常
                    e.printStackTrace();
                }
                if(Main.Debug) {
                    long endTime = System.currentTimeMillis(); // 记录结束时间
                    long duration = endTime - startTime; // 计算耗时
                    System.out.println("[调试 - 清理] 本次清理所有方块总计耗时 " + duration + " ms");
                }
            });
        }
    }

    public static void fillMinerAll(List<BlockRegion> blockRegionList){
        World world = Main.gameData.getWorld();
        Material material = Material.DIAMOND_BLOCK;
        for (BlockRegion blockRegion : blockRegionList) {
            CompletableFuture.runAsync(() -> {
                long startTime = System.currentTimeMillis(); // 记录开始时间
                int minX = blockRegion.getMinX();
                int maxX = blockRegion.getMaxX();
                CuboidRegion cuboidRegion = ComputeBlock.getCuboidRegion(minX,maxX);
                try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(world))) {
                    // 在编辑会话中设置长方体区域内的所有方块为指定的材质
                    editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(material));
                } catch (Exception e) {
                    // 捕获并打印任何可能发生的异常
                    e.printStackTrace();
                }
                if(Main.Debug) {
                    long endTime = System.currentTimeMillis(); // 记录结束时间
                    long duration = endTime - startTime; // 计算耗时
                    System.out.println("[调试 - 修复] 本次修复所有方块总计耗时 " + duration + " ms");
                }
            });
        }
    }
}
