package me.Demon.BlockWars.Util;

import me.Demon.BlockWars.Main;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class ConfigYml {
    private String minersize;
    private int countdownTime;
    private int circularMax;
    private int heightMax;
    private int completeAmount;
    private int dianzan_amount;
    private int dianzan_need;
    private String dianzan_event;
    private HashMap<String,List<String>> randonBoxList = new HashMap<>();
    private HashMap<String, Integer> gameSettings = new HashMap<>();
    public ConfigYml(){
        this.dianzan_amount = 0;
        FileConfiguration settings_yml = Main.plugin.getConfig();
        this.minersize = settings_yml.getString("minersize");
        this.circularMax = settings_yml.getInt("circularMax");
        this.heightMax = settings_yml.getInt("heightMax");
        this.completeAmount = settings_yml.getInt("completeAmount");
        this.countdownTime = settings_yml.getInt("countdownTime");
        Bukkit.getConsoleSender().sendMessage("[日志 - 炸弹填充] 游戏设置:");
        if(settings_yml.getConfigurationSection("Settings") != null){
            Bukkit.getConsoleSender().sendMessage("设置: 最大圈数  "+this.circularMax+"圈");
            Bukkit.getConsoleSender().sendMessage("设置: 最大高度  "+this.heightMax+"层");
            for (String buttKey : settings_yml.getConfigurationSection("Settings").getKeys(false)){
                int settings_type = settings_yml.getInt("Settings."+buttKey);
                gameSettings.put(buttKey, settings_type);
                Bukkit.getConsoleSender().sendMessage("设置: "+buttKey+"  "+getSwitchString(settings_type));
            }
        }
    }

    public void LoadDianEvent(FileConfiguration yml){
        this.dianzan_need = 300;
        if(yml.getInt("LiveLike.needamount") >= 1){
            this.dianzan_need = yml.getInt("LiveLike.needamount");
        }
        this.dianzan_event = "小雷王";
        if(yml.getString("LiveLike.event") != null){
            this.dianzan_event = yml.getString("LiveLike.event");
        }
    }

    // 保存配置文件
    public void SaveSettingsConfig(){
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set("minersize",this.minersize);
        yml.set("completeAmount",this.completeAmount);
        yml.set("countdownTime",this.countdownTime);
        for (String buttKey : gameSettings.keySet()) {
            yml.set("Settings."+buttKey,gameSettings.get(buttKey));
        }
        Main.plugin.saveConfig();
    }

    public List<String> getRandonBoxList(String box_type) {
        if(this.randonBoxList.get(box_type) != null){
            return this.randonBoxList.get(box_type);
        }
        return new ArrayList<>();
    }

    public boolean isGameSettings(String buttKey){
        if(gameSettings.get(buttKey) != null){
            int type = gameSettings.get(buttKey);
            if(type == 1){
                return true;
            }
        }
        return false;
    }
    public int getGameSettings(String buttKey){
        if(gameSettings.get(buttKey) != null){
            return gameSettings.get(buttKey);
        }
        return 0;
    }

    public void setGameSettings(String buttKey,int settings_type){
        if(gameSettings.get(buttKey) != null){
            gameSettings.put(buttKey,settings_type);
        }
        gameSettings.put(buttKey,settings_type);
    }

    public int getDianzan_need() {
        return dianzan_need;
    }

    public String getDianzan_event() {
        return dianzan_event;
    }

    public int getCountdownTime() {
        return countdownTime;
    }
    public String getSwitchString(int butt){
        if(butt == 1){
            return "开启";
        }
        return "关闭";
    }
    public int getDianzan_amount() {
        return dianzan_amount;
    }
    public void addDianzan_amount(int add_amount){
        setDianzan_amount(dianzan_amount+add_amount);
    }
    public void setDianzan_amount(int dianzan_amount) {
        this.dianzan_amount = dianzan_amount;
    }
}
