package me.Demon.BlockWars.Util;

import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.extent.clipboard.Clipboard;
import com.sk89q.worldedit.extent.clipboard.io.ClipboardFormats;
import com.sk89q.worldedit.math.BlockVector3;
import me.Demon.BlockWars.Main;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Pig;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.io.File;

public class GameUtil {

    public static boolean AntiGiftEvent = false;

    public static void setAntiGiftEvent(boolean antiGiftEvent) {
        AntiGiftEvent = antiGiftEvent;
    }

    public static boolean isAntiGiftEvent() {
        return AntiGiftEvent;
    }

    public static void ClearWorldEntity(){
        for (Entity entity : Main.gameData.getWorld().getEntities()) {
            if(!(entity instanceof Player)){
                if(Main.configYml.isGameSettings("pigkills")) {
                    if(!(entity instanceof Pig)){
                        entity.remove();
                    }
                }else {
                    entity.remove();
                }
                continue;
            }
        }
    }

    public static void loadSchematics(String fileName) {
        int minerY = 3;
        File schema_file = new File("plugins/FastAsyncWorldEdit/schematics",fileName+".schem");
        Location location = new Location(Main.gameData.getWorld(),87.5,minerY,-1.5);
        World world = location.getWorld();
        EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(world));
        Bukkit.getScheduler().runTaskAsynchronously (Main.plugin, () -> {
                    try {
                        Clipboard clipboard = ClipboardFormats.findByFile(schema_file).load(schema_file);
                        clipboard.paste(BukkitAdapter.adapt(world), BlockVector3.at(location.getBlockX(), location.getBlockY(), location.getBlockZ()));
                        clipboard.flush();
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        editSession.close();
                    }
                }
        );
    }

    public static void refreshPlayerHandStack(Player p){
        Material material = Material.IRON_BLOCK;
        int rand = RandomUtil.getRandomInt(1,100);
        if(rand >= 75){
            material = Material.GOLD_BLOCK;
        }else if(rand >= 50){
            material = Material.DIAMOND_BLOCK;
        }else if(rand >= 25){
            material = Material.EMERALD_BLOCK;
        }
        Inventory inv = p.getInventory();
        for (int i = 0; i < 9;i++){
            ItemStack item = inv.getItem(i);
            if(item != null && item.getType() != Material.AIR){
                if(item.getType().name().contains("_BLOCK")){
                    inv.setItem(i, new ItemStack(Material.AIR));
                    inv.setItem(i, new ItemStack(material));
                }
            }else {
                inv.setItem(i, new ItemStack(Material.AIR));
                inv.setItem(i, new ItemStack(material));
            }
        }
    }

}
